/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: IBasicCluePoolFactory.java 4389 2008-12-15 13:48:57Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.pool.impl.enhanced.api.basic.clue;

import org.ow2.util.pool.impl.enhanced.api.IPoolItemFactory;
import org.ow2.util.pool.impl.enhanced.api.basic.IBasicPoolFactory;
import org.ow2.util.pool.impl.enhanced.api.basic.clue.accessmanager.IClueAccessManager;
import org.ow2.util.pool.impl.enhanced.api.clue.IClueManager;
import org.ow2.util.pool.impl.enhanced.api.clue.ICluePoolFactory;
import org.ow2.util.pool.impl.enhanced.api.clue.basiccluemanager.IClueAccessor;

/**
 * Pool factory.
 * @author Gael Lalire
 */
public interface IBasicCluePoolFactory extends IBasicPoolFactory, ICluePoolFactory {

    <E extends IClueAccessor<C>, C> IBasicCluePool<E, C> createBasicCluePool(IPoolItemFactory<E> poolItemFactory);

    <E extends IClueAccessor<C>, C> IBasicCluePool<E, C> createBasicCluePool(IPoolItemFactory<E> poolItemFactory,
            int initPoolSize);

    <E, C> IBasicCluePool<E, C> createCluePool(IPoolItemFactory<E> poolItemFactory, IClueManager<E, C> clueManager);

    <E, C> IBasicCluePool<E, C> createBasicCluePool(IPoolItemFactory<E> poolItemFactory, IClueManager<E, C> clueManager);

    <E, C> IBasicCluePool<E, C> createBasicCluePool(IPoolItemFactory<E> poolItemFactory, int initPoolSize,
            IClueManager<E, C> clueManager);

    public <E, C> IBasicCluePool<E, C> createBasicCluePool(final IPoolItemFactory<E> poolItemFactory, final int initPoolSize,
            final IClueAccessManager<E, C> clueAccessManager);

}
